<template>
  <div class="advance-search">
    <div class="search-content">
      <form>
        <div class="fields">
          <div id="left-part">
            <div class="form-content">
              <label class="form-label">Tracking nr.:</label>
              <input type="text" class="form-value" placeholder="Tracking nr" id="track"/>
            </div>
            <div class="form-content">
              <label class="form-label">Status:</label>
              <select class="form-value" id="status">
                <option value="0" selected>Select a status</option>
                <option value="1"> processing </option>
                <option value="2"> processed </option>
                <option value="3"> in progress </option>
                <option value="4"> delivered </option>
                <option value="5"> rejected </option>
              </select>
            </div>
          </div>
          <div id="right-part">
            <div class="form-content">
              <label class="form-label">Sent date:</label>
              <input type="date" class="form-value" id="date"/>
            </div>
            <div class="form-content">
              <label class="form-label">Payed:</label>
              <input type="checkbox" class="form-value" id="check"/>
            </div>
          </div>
        </div>
        <div class="form-content" id="buttons">
          <input type="button" value="Search" class="form-button" v-on:click="search()"/>
        </div>
      </form>
      <div class="tab-wrapper">
        <table class="tab">
          <thead>
            <tr>
              <th>Tracking Nr</th>
              <th>Status</th>
              <th>Sent date</th>
              <th>Due amount</th>
              <th></th>
            </tr>
          </thead>
          <tbody>
            <tr v-for="value in searched" v-bind:key="value.id" v-bind:item="value">
            <td>{{value.trackingId}}</td>
            <td>{{value.status}}</td>
            <td>
              {{value.sentDate}}
            </td>
            <td>{{value.dueAmount}}</td>
            <td>
              <button v-on:click="see(value)">See details</button>
            </td>
          </tr>
          </tbody>
        </table>
      </div>
    </div>
  </div>
</template>

<script>
import axios from 'axios';

export default {
  name: 'advanceSearch',
  props: {
    user: Object,
  },
  data() {
    return {
      deliveries: [],
      searched: [],
    };
  },
  mounted() {
    this.get();
  },
  methods: {
    get() {
      const url = 'http://localhost:4000/api/deliveries/';
      axios.get(url).then(
        (result) => {
          this.deliveries = result.data;
          this.searched = result.data;
        },
      ).catch((error) => {
        console.log(error);
      });
      console.log(this.searched);
    },
    search() {
      const track = document.getElementById('track').value;
      const date = document.getElementById('date').value;
      const status = document.getElementById('status').value;
      const isPaid = document.getElementById('check').value;

      if (track && !date && !status && !isPaid) {
        this.searched = this.deliveries.find(e => e.parcel.trackingNr === track);
      } else if (!track && date && !status && !isPaid) {
        this.searched = this.deliveries.find(e => e.parcel.sendDate === date);
      } else if (!track && !date && status && !isPaid) {
        this.searched = this.deliveries.find(e => e.status === status);
      } else if (!track && !date && !status && isPaid) {
        this.searched = this.deliveries.find(e => e.parcel.isPaid === isPaid);
      } else {
        let test = [];
        if (track) {
          test = this.deliveries.find(e => e.trackingId === track);
        }
        if (date) {
          test = this.deliveries.find(e => e.sentDate === date);
        }
        if (status) {
          test = this.deliveries.find(e => e.status === status);
        }
        if (isPaid) {
          test = this.deliveries.find(e => e.isPayed === isPaid);
        }
        this.searched = test;
      }
    },
    see() {
      this.$emit('change-component', 'Details');
      // this.$emit('delivery', value);
    },
  },
};
</script>

<style scoped>
</style>
